//
//  ColorPalette.java
//  Treehousestudio
//
//  Created by john maeda on Fri Aug 16 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//


import java.awt.*;
import java.applet.*;
import java.util.*;

import THSPanel;

public class ColorPalette extends THSPanel {
    public Color fgcol=Color.black;
    public Color bgcol=Color.white;
    static final int NUMHUES=24;
    static final int NUMCATEGORIES= 10;
    static final int XMARGIN= 1;
    static final int YMARGIN= 1;

    Color xsugurucol[][] = new Color[NUMHUES][NUMCATEGORIES];

    public void SETCOL(int x, int y, int r, int g, int b)
    {
        xsugurucol[x][y] = new Color(r>>8,g>>8,b>>8);
    }
    Applet app;
    Image cim;
    Rectangle fgrect=null,bgrect;
    int cimw, cimh;

    boolean fgbgp = true;

    public ColorPalette(int _x, int _y, int _w, int _h, int _type, Applet _app, boolean _fgbgp)
    {
        super("Color Palette",_x,_y,_w,_h);
        fgbgp = _fgbgp;

        app = _app;
        /* id: 'VIVID-1PR */
        SETCOL(0,0,60416,0,20736);
        /* id: 'VIVID-2R */
        SETCOL(1,0,61952,0,0);
        /* id: 'VIVID-3YR */
        SETCOL(2,0,65280,19712,0);
        /* id: 'VIVID-4RO */
        SETCOL(3,0,65280,25088,0);
        /* id: 'VIVID-5O */
        SETCOL(4,0,65280,33024,0);
        /* id: 'VIVID-6YO */
        SETCOL(5,0,65280,40704,0);
        /* id: 'VIVID-7RY */
        SETCOL(6,0,65280,45824,0);
        /* id: 'VIVID-8Y */
        SETCOL(7,0,65280,55552,0);
        /* id: 'VIVID-9GY */
        SETCOL(8,0,60416,52480,0);
        /* id: 'VIVID-10YG */
        SETCOL(9,0,45312,50432,0);
        /* id: 'VIVID-11YG */
        SETCOL(10,0,29184,47616,0);
        /* id: 'VIVID-12G */
        SETCOL(11,0,14592,42496,12288);
        /* id: 'VIVID-13BG */
        SETCOL(12,0,0,38144,24576);
        /* id: 'VIVID-14BG */
        SETCOL(13,0,0,35072,30720);
        /* id: 'VIVID-15BG */
        SETCOL(14,0,0,32768,34560);
        /* id: 'VIVID-16GB */
        SETCOL(15,0,0,28672,38144);
        /* id: 'VIVID-17B */
        SETCOL(16,0,0,28160,38656);
        /* id: 'VIVID-18B */
        SETCOL(17,0,0,18944,41472);
        /* id: 'VIVID-19B */
        SETCOL(18,0,24576,0,45824);
        /* id: 'VIVID-20V */
        SETCOL(19,0,33792,0,49664);
        /* id: 'VIVID-21P */
        SETCOL(20,0,42240,0,51712);
        /* id: 'VIVID-22P */
        SETCOL(21,0,48384,0,40960);
        /* id: 'VIVID-23RP */
        SETCOL(22,0,50688,0,38912);
        /* id: 'VIVID-24RP */
        SETCOL(23,0,46336,0,21248);
        /* id: 'BRIGHT-1PR */
        SETCOL(0,1,65280,27648,25344);
        /* id: 'BRIGHT-2R */
        SETCOL(1,1,65280,29696,24320);
        /* id: 'BRIGHT-3YR */
        SETCOL(2,1,65280,32768,22528);
        /* id: 'BRIGHT-4RO */
        SETCOL(3,1,65280,34304,19456);
        /* id: 'BRIGHT-5O */
        SETCOL(4,1,65280,41216,23552);
        /* id: 'BRIGHT-6YO */
        SETCOL(5,1,65280,43776,23040);
        /* id: 'BRIGHT-7RY */
        SETCOL(6,1,65280,46592,24320);
        /* id: 'BRIGHT-8Y */
        SETCOL(7,1,65280,55552,22272);
        /* id: 'BRIGHT-9GY */
        SETCOL(8,1,59392,54016,17920);
        /* id: 'BRIGHT-10YG */
        SETCOL(9,1,54272,55552,16128);
        /* id: 'BRIGHT-11YG */
        SETCOL(10,1,44288,54016,21760);
        /* id: 'BRIGHT-12G */
        SETCOL(11,1,26368,51456,31744);
        /* id: 'BRIGHT-13BG */
        SETCOL(12,1,20736,44800,33536);
        /* id: 'BRIGHT-14BG */
        SETCOL(13,1,20736,41984,37120);
        /* id: 'BRIGHT-15BG */
        SETCOL(14,1,20736,40192,41472);
        /* id: 'BRIGHT-16GB */
        SETCOL(15,1,20736,37632,43008);
        /* id: 'BRIGHT-17B */
        SETCOL(16,1,20736,32000,41216);
        /* id: 'BRIGHT-18B */
        SETCOL(17,1,20736,29440,41216);
        /* id: 'BRIGHT-19B */
        SETCOL(18,1,25856,23808,41728);
        /* id: 'BRIGHT-20V */
        SETCOL(19,1,32768,23808,43008);
        /* id: 'BRIGHT-21P */
        SETCOL(20,1,41984,28928,43008);
        /* id: 'BRIGHT-22P */
        SETCOL(21,1,51200,28160,42496);
        /* id: 'BRIGHT-23RP */
        SETCOL(22,1,58112,28160,42496);
        /* id: 'BRIGHT-24RP */
        SETCOL(23,1,64256,29440,36608);
        /* id: 'LIGHT-1PR */
        SETCOL(0,2,65280,34560,34816);
        /* id: 'LIGHT-2R */
        SETCOL(1,2,65280,37632,30976);
        /* id: 'LIGHT-3YR */
        SETCOL(2,2,65280,40448,30976);
        /* id: 'LIGHT-4RO */
        SETCOL(3,2,65280,43264,30976);
        /* id: 'LIGHT-5O */
        SETCOL(4,2,65280,45312,32512);
        /* id: 'LIGHT-6YO */
        SETCOL(5,2,65280,47104,34560);
        /* id: 'LIGHT-7RY */
        SETCOL(6,2,65280,49152,30208);
        /* id: 'LIGHT-8Y */
        SETCOL(7,2,65280,53760,27648);
        /* id: 'LIGHT-9GY */
        SETCOL(8,2,59392,56576,26112);
        /* id: 'LIGHT-10YG */
        SETCOL(9,2,52224,60160,23296);
        /* id: 'LIGHT-11YG */
        SETCOL(10,2,48640,57856,33280);
        /* id: 'LIGHT-12G */
        SETCOL(11,2,44032,55808,38912);
        /* id: 'LIGHT-13BG */
        SETCOL(12,2,38400,53504,38400);
        /* id: 'LIGHT-14BG */
        SETCOL(13,2,33536,50176,39680);
        /* id: 'LIGHT-15BG */
        SETCOL(14,2,33536,48384,43776);
        /* id: 'LIGHT-16GB */
        SETCOL(15,2,34304,47104,48128);
        /* id: 'LIGHT-17B */
        SETCOL(16,2,37120,45824,51968);
        /* id: 'LIGHT-18B */
        SETCOL(17,2,40960,44800,55296);
        /* id: 'LIGHT-19B */
        SETCOL(18,2,46080,44800,55296);
        /* id: 'LIGHT-20V */
        SETCOL(19,2,52224,43008,61184);
        /* id: 'LIGHT-21P */
        SETCOL(20,2,55808,40704,58112);
        /* id: 'LIGHT-22P */
        SETCOL(21,2,59392,38656,50944);
        /* id: 'LIGHT-23RP */
        SETCOL(22,2,61952,39424,45824);
        /* id: 'LIGHT-24RP */
        SETCOL(23,2,65280,39936,40704);
        /* id: 'PALE-1PR */
        SETCOL(0,3,65280,51200,49408);
        /* id: 'PALE-2R */
        SETCOL(1,3,65280,53504,48896);
        /* id: 'PALE-3YR */
        SETCOL(2,3,65280,54528,48128);
        /* id: 'PALE-4RO */
        SETCOL(3,3,65280,55040,47872);
        /* id: 'PALE-5O */
        SETCOL(4,3,65280,54528,46848);
        /* id: 'PALE-6YO */
        SETCOL(5,3,65280,54528,44800);
        /* id: 'PALE-7RY */
        SETCOL(6,3,65280,56320,44800);
        /* id: 'PALE-8Y */
        SETCOL(7,3,65280,58624,43008);
        /* id: 'PALE-9GY */
        SETCOL(8,3,64768,59392,42752);
        /* id: 'PALE-10YG */
        SETCOL(9,3,64000,60672,43264);
        /* id: 'PALE-11YG */
        SETCOL(10,3,60160,60160,43264);
        /* id: 'PALE-12G */
        SETCOL(11,3,55552,59136,43264);
        /* id: 'PALE-13BG */
        SETCOL(12,3,54272,59392,46080);
        /* id: 'PALE-14BG */
        SETCOL(13,3,54272,59392,48896);
        /* id: 'PALE-15BG */
        SETCOL(14,3,52992,57856,50688);
        /* id: 'PALE-16GB */
        SETCOL(15,3,51712,55552,52480);
        /* id: 'PALE-17B */
        SETCOL(16,3,52736,54272,53760);
        /* id: 'PALE-18B */
        SETCOL(17,3,54784,52480,55808);
        /* id: 'PALE-19B */
        SETCOL(18,3,56576,51968,56576);
        /* id: 'PALE-20V */
        SETCOL(19,3,58368,51456,56832);
        /* id: 'PALE-21P */
        SETCOL(20,3,60416,51456,54784);
        /* id: 'PALE-22P */
        SETCOL(21,3,62464,51456,53248);
        /* id: 'PALE-23RP */
        SETCOL(22,3,63488,51456,52480);
        /* id: 'PALE-24RP */
        SETCOL(23,3,65024,51456,51712);
        /* id: 'LIGHTGRAYISH-1PR */
        SETCOL(0,4,49664,38144,36608);
        /* id: 'LIGHTGRAYISH-2R */
        SETCOL(1,4,52224,39168,36096);
        /* id: 'LIGHTGRAYISH-3YR */
        SETCOL(2,4,53760,39424,34304);
        /* id: 'LIGHTGRAYISH-4RO */
        SETCOL(3,4,54784,39680,34048);
        /* id: 'LIGHTGRAYISH-5O */
        SETCOL(4,4,56064,41728,32768);
        /* id: 'LIGHTGRAYISH-6YO */
        SETCOL(5,4,57088,44032,31744);
        /* id: 'LIGHTGRAYISH-7RY */
        SETCOL(6,4,55040,44800,30720);
        /* id: 'LIGHTGRAYISH-8Y */
        SETCOL(7,4,53760,45568,29696);
        /* id: 'LIGHTGRAYISH-9GY */
        SETCOL(8,4,50176,45568,29696);
        /* id: 'LIGHTGRAYISH-10YG */
        SETCOL(9,4,45824,45568,30464);
        /* id: 'LIGHTGRAYISH-11YG */
        SETCOL(10,4,43520,45568,34304);
        /* id: 'LIGHTGRAYISH-12G */
        SETCOL(11,4,40704,45824,37376);
        /* id: 'LIGHTGRAYISH-13BG */
        SETCOL(12,4,40704,44800,39424);
        /* id: 'LIGHTGRAYISH-14BG */
        SETCOL(13,4,40704,43776,41728);
        /* id: 'LIGHTGRAYISH-15BG */
        SETCOL(14,4,40704,42496,42240);
        /* id: 'LIGHTGRAYISH-16GB */
        SETCOL(15,4,39936,40960,42752);
        /* id: 'LIGHTGRAYISH-17B */
        SETCOL(16,4,41216,40704,43264);
        /* id: 'LIGHTGRAYISH-18B */
        SETCOL(17,4,42496,40448,44544);
        /* id: 'LIGHTGRAYISH-19B */
        SETCOL(18,4,44800,40448,44288);
        /* id: 'LIGHTGRAYISH-20V */
        SETCOL(19,4,46848,40448,43008);
        /* id: 'LIGHTGRAYISH-21P */
        SETCOL(20,4,47872,40448,42240);
        /* id: 'LIGHTGRAYISH-22P */
        SETCOL(21,4,48384,39680,40960);
        /* id: 'LIGHTGRAYISH-23RP */
        SETCOL(22,4,48128,38912,39424);
        /* id: 'LIGHTGRAYISH-24RP */
        SETCOL(23,4,47360,37120,38656);
        /* id: 'DULL-1PR */
        SETCOL(0,5,44544,25856,27392);
        /* id: 'DULL-2R */
        SETCOL(1,5,47616,29440,26624);
        /* id: 'DULL-3YR */
        SETCOL(2,5,47872,30720,26368);
        /* id: 'DULL-4RO */
        SETCOL(3,5,47872,32256,26368);
        /* id: 'DULL-5O */
        SETCOL(4,5,48640,33792,25088);
        /* id: 'DULL-6YO */
        SETCOL(5,5,49408,36096,24832);
        /* id: 'DULL-7RY */
        SETCOL(6,5,48640,37632,25088);
        /* id: 'DULL-8Y */
        SETCOL(7,5,47360,39424,24832);
        /* id: 'DULL-9GY */
        SETCOL(8,5,45056,40704,24832);
        /* id: 'DULL-10YG */
        SETCOL(9,5,43008,41728,24832);
        /* id: 'DULL-11YG */
        SETCOL(10,5,37888,40960,27904);
        /* id: 'DULL-12G */
        SETCOL(11,5,32768,40192,30976);
        /* id: 'DULL-13BG */
        SETCOL(12,5,31232,38400,32512);
        /* id: 'DULL-14BG */
        SETCOL(13,5,27904,36608,33280);
        /* id: 'DULL-15BG */
        SETCOL(14,5,25856,34560,34560);
        /* id: 'DULL-16GB */
        SETCOL(15,5,22272,32512,35328);
        /* id: 'DULL-17B */
        SETCOL(16,5,21504,29696,35328);
        /* id: 'DULL-18B */
        SETCOL(17,5,19456,26112,35328);
        /* id: 'DULL-19B */
        SETCOL(18,5,25088,26112,35328);
        /* id: 'DULL-20V */
        SETCOL(19,5,32512,26112,35328);
        /* id: 'DULL-21P */
        SETCOL(20,5,35840,26112,34816);
        /* id: 'DULL-22P */
        SETCOL(21,5,39680,26112,33280);
        /* id: 'DULL-23RP */
        SETCOL(22,5,40448,24064,29952);
        /* id: 'DULL-24RP */
        SETCOL(23,5,41472,22272,27392);
        /* id: 'GRAYISH-1PR */
        SETCOL(0,6,35072,24064,26368);
        /* id: 'GRAYISH-2R */
        SETCOL(1,6,39168,25856,23808);
        /* id: 'GRAYISH-3YR */
        SETCOL(2,6,39168,25856,22272);
        /* id: 'GRAYISH-4RO */
        SETCOL(3,6,39936,25856,20480);
        /* id: 'GRAYISH-5O */
        SETCOL(4,6,39936,27392,20480);
        /* id: 'GRAYISH-6YO */
        SETCOL(5,6,39936,29184,20224);
        /* id: 'GRAYISH-7RY */
        SETCOL(6,6,39936,31488,20736);
        /* id: 'GRAYISH-8Y */
        SETCOL(7,6,39168,32768,22272);
        /* id: 'GRAYISH-9GY */
        SETCOL(8,6,36352,32512,22272);
        /* id: 'GRAYISH-10YG */
        SETCOL(9,6,33792,30976,22272);
        /* id: 'GRAYISH-11YG */
        SETCOL(10,6,31232,30208,22272);
        /* id: 'GRAYISH-12G */
        SETCOL(11,6,28928,28928,22528);
        /* id: 'GRAYISH-13BG */
        SETCOL(12,6,27648,28928,24576);
        /* id: 'GRAYISH-14BG */
        SETCOL(13,6,25344,29184,25344);
        /* id: 'GRAYISH-15BG */
        SETCOL(14,6,24064,27648,27392);
        /* id: 'GRAYISH-16GB */
        SETCOL(15,6,20992,25856,29184);
        /* id: 'GRAYISH-17B */
        SETCOL(16,6,24064,25856,29696);
        /* id: 'GRAYISH-18B */
        SETCOL(17,6,27648,25856,31232);
        /* id: 'GRAYISH-19B */
        SETCOL(18,6,29440,25856,31232);
        /* id: 'GRAYISH-20V */
        SETCOL(19,6,31232,25856,31232);
        /* id: 'GRAYISH-21P */
        SETCOL(20,6,32256,25856,31232);
        /* id: 'GRAYISH-22P */
        SETCOL(21,6,33280,25856,32000);
        /* id: 'GRAYISH-23RP */
        SETCOL(22,6,32768,24064,29440);
        /* id: 'GRAYISH-24RP */
        SETCOL(23,6,32000,22528,28160);
        /* id: 'DEEP-1PR */
        SETCOL(0,7,38656,0,23040);
        /* id: 'DEEP-2R */
        SETCOL(1,7,40704,0,16640);
        /* id: 'DEEP-3YR */
        SETCOL(2,7,44288,0,6656);
        /* id: 'DEEP-4RO */
        SETCOL(3,7,44288,17152,0);
        /* id: 'DEEP-5O */
        SETCOL(4,7,46848,22528,0);
        /* id: 'DEEP-6YO */
        SETCOL(5,7,46848,27392,0);
        /* id: 'DEEP-7RY */
        SETCOL(6,7,46848,31488,0);
        /* id: 'DEEP-8Y */
        SETCOL(7,7,46848,36096,0);
        /* id: 'DEEP-9GY */
        SETCOL(8,7,43520,36608,0);
        /* id: 'DEEP-10YG */
        SETCOL(9,7,33024,36352,0);
        /* id: 'DEEP-11YG */
        SETCOL(10,7,24576,34304,0);
        /* id: 'DEEP-12G */
        SETCOL(11,7,0,30976,13824);
        /* id: 'DEEP-13BG */
        SETCOL(12,7,0,30208,21760);
        /* id: 'DEEP-14BG */
        SETCOL(13,7,0,29440,26880);
        /* id: 'DEEP-15BG */
        SETCOL(14,7,0,25856,27136);
        /* id: 'DEEP-16GB */
        SETCOL(15,7,0,23296,29696);
        /* id: 'DEEP-17B */
        SETCOL(16,7,0,22784,32512);
        /* id: 'DEEP-18B */
        SETCOL(17,7,0,19200,30464);
        /* id: 'DEEP-19B */
        SETCOL(18,7,0,12800,30464);
        /* id: 'DEEP-20V */
        SETCOL(19,7,16896,10496,33536);
        /* id: 'DEEP-21P */
        SETCOL(20,7,28928,4864,33536);
        /* id: 'DEEP-22P */
        SETCOL(21,7,38912,0,33536);
        /* id: 'DEEP-23RP */
        SETCOL(22,7,44800,0,33024);
        /* id: 'DEEP-24RP */
        SETCOL(23,7,44032,0,23040);
        /* id: 'DARK-1PR */
        SETCOL(0,8,28160,13568,21248);
        /* id: 'DARK-2R */
        SETCOL(1,8,30208,12800,18944);
        /* id: 'DARK-3YR */
        SETCOL(2,8,33792,15872,18944);
        /* id: 'DARK-4RO */
        SETCOL(3,8,37120,20992,18944);
        /* id: 'DARK-5O */
        SETCOL(4,8,35328,20992,16896);
        /* id: 'DARK-6YO */
        SETCOL(5,8,32768,20992,13312);
        /* id: 'DARK-7RY */
        SETCOL(6,8,32768,23040,8960);
        /* id: 'DARK-8Y */
        SETCOL(7,8,32768,25856,3072);
        /* id: 'DARK-9GY */
        SETCOL(8,8,28672,24832,4096);
        /* id: 'DARK-10YG */
        SETCOL(9,8,25600,23552,4096);
        /* id: 'DARK-11YG */
        SETCOL(10,8,16896,22784,7168);
        /* id: 'DARK-12G */
        SETCOL(11,8,7168,21760,15360);
        /* id: 'DARK-13BG */
        SETCOL(12,8,1792,20480,17408);
        /* id: 'DARK-14BG */
        SETCOL(13,8,7680,19200,18944);
        /* id: 'DARK-15BG */
        SETCOL(14,8,2048,18432,19456);
        /* id: 'DARK-16GB */
        SETCOL(15,8,0,17664,20992);
        /* id: 'DARK-17B */
        SETCOL(16,8,0,15360,22528);
        /* id: 'DARK-18B */
        SETCOL(17,8,0,13056,23552);
        /* id: 'DARK-19B */
        SETCOL(18,8,9728,9472,24064);
        /* id: 'DARK-20V */
        SETCOL(19,8,14848,4352,23296);
        /* id: 'DARK-21P */
        SETCOL(20,8,19456,3584,23296);
        /* id: 'DARK-22P */
        SETCOL(21,8,23808,3840,23296);
        /* id: 'DARK-23RP */
        SETCOL(22,8,27136,3840,22528);
        /* id: 'DARK-24RP */
        SETCOL(23,8,31232,5888,22528);
        /* id: 'GRAY-N8 */
        SETCOL(0,9,65280,65280,65280);
        /* id: 'GRAY-N7 */
        SETCOL(1,9,57344,57344,57344);
        /* id: 'GRAY-N6 */
        SETCOL(2,9,49152,49152,49152);
        /* id: 'GRAY-N5 */
        SETCOL(3,9,40960,40960,40960);
        /* id: 'GRAY-N4 */
        SETCOL(4,9,32768,32768,32768);
        /* id: 'GRAY-N3 */
        SETCOL(5,9,24576,24576,24576);
        /* id: 'GRAY-N2 */
        SETCOL(6,9,16384,16384,16384);
        /* id: 'GRAY-N1 */
        SETCOL(7,9,8192,8192,8192);
        /* id: 'GRAY-N0 */
        SETCOL(8,9,0,0,0);
        cim = app.createImage(NUMHUES*7+XMARGIN*(NUMHUES)+1,NUMCATEGORIES*10+YMARGIN*(NUMCATEGORIES)+1);
        drawsugurupal(cim.getGraphics(),0,0,
                      cimw=(NUMHUES*7+XMARGIN*(NUMHUES)),cimh=(NUMCATEGORIES*10+YMARGIN*(NUMCATEGORIES)));
    }
    int c_category = 1, c_hue =1;
    public void drawsugurupal(Graphics g, int cx, int cy, int cw, int ch)
    {
        int width = cw;
        int height = ch;
        int i, j;
        int x, y;
        int c_category = 1, c_hue =1;
        int c_stridex = (width-NUMHUES*XMARGIN + XMARGIN)/NUMHUES;
        int c_stridey = (height-NUMCATEGORIES*YMARGIN + YMARGIN)/NUMCATEGORIES;
        g.setColor(Color.black);
        g.fillRect(cx,cy,cw,ch);
        g.setColor(Color.black);
        g.drawRect(cx,cy,cw,ch);
        y = cy+YMARGIN;
        for(i = 0; i < NUMCATEGORIES; i++, y += YMARGIN + c_stridey) {
            x = cx+XMARGIN;
            if (i != NUMCATEGORIES-1) {
                for(j = 0; j < NUMHUES; j++, x+= XMARGIN + c_stridex) {
                    g.setColor(xsugurucol[j][i]);
                    g.fillRect(x,y,c_stridex,c_stridey);
                }
            } else {
                j = 8;
                g.setColor(xsugurucol[j][i]);
                g.fillRect(x,y,c_stridex,c_stridey);
                x+=XMARGIN+c_stridex;
                for(j = 0; j < 8; j++, x+= XMARGIN + c_stridex) {
                    g.setColor(xsugurucol[j][i]);
                    g.fillRect(x,y,c_stridex,c_stridey);
                }
            }
        }
    }

    public void drawhighl(Graphics g, int cx, int cy, int cw, int ch)
    {
        int width = cw;
        int height = ch;
        int i, j;
        int x, y;
        int c_stridex = (width-NUMHUES*XMARGIN + XMARGIN)/NUMHUES;
        int c_stridey = (height-NUMCATEGORIES*YMARGIN + YMARGIN)/NUMCATEGORIES;
        y = cy+YMARGIN;

        for(i = 0; i < NUMCATEGORIES; i++, y += YMARGIN + c_stridey) {
            x = cx+XMARGIN;
            if (i != NUMCATEGORIES-1) {
                for(j = 0; j < NUMHUES; j++, x+= XMARGIN + c_stridex) {
                    if (ptinrect(x,y,c_stridex,c_stridey,curmx,curmy)) {
                        c_category = i; c_hue = j;
                        if (mfgp) fgcol =xsugurucol[j][i];
                        else bgcol = xsugurucol[j][i];
                    }
                    if (c_category == i && c_hue == j) {
                        g.setColor(Color.white);
                        g.drawRect(x,y,c_stridex-1,c_stridey-1);
                    }
                }
            } else {
                j = 8;
                if (ptinrect(x,y,c_stridex,c_stridey,curmx,curmy)) {
                    c_category = i; c_hue = j;
                    if (mfgp) fgcol =xsugurucol[j][i];
                    else bgcol = xsugurucol[j][i];
                }
                if (c_category == i && c_hue == j) {
                    g.setColor(Color.white);
                    g.drawRect(x,y,c_stridex-1,c_stridey-1);
                    g.setColor(Color.black);
                    g.drawRect(x+1,y+1,c_stridex-1-2,c_stridey-1-2);
                }
                x+=XMARGIN+c_stridex;
                for(j = 0; j < 8; j++, x+= XMARGIN + c_stridex) {
                    if (ptinrect(x,y,c_stridex,c_stridey,curmx,curmy)) {
                        c_category = i; c_hue = j;
                        if (mfgp) fgcol =xsugurucol[j][i];
                        else bgcol = xsugurucol[j][i];
                    }
                    if (c_category == i && c_hue == j) {
                        g.setColor(Color.white);
                        g.drawRect(x,y,c_stridex-1,c_stridey-1);
                        g.setColor(Color.black);
                        g.drawRect(x+1,y+1,c_stridex-1-2,c_stridey-1-2);
                    }
                }
            }
        }
    }


    boolean mdownp = false;
    boolean mfgp = false;
    int curmx, curmy;

    public boolean ptinrect(Rectangle r, int x, int y)
    {
        return x>r.x&&x<(r.x+r.width)&&y>r.y&&y<(r.y+r.height);
    }
    public boolean ptinrect(int x1, int y1, int x2, int y2, int x, int y)
    {
        return x>x1&&x<(x1+x2)&&y>y1&&y<(y1+y2);
    }
    boolean colchangep = false;

    public void mouseDown(Event ev, int mx, int my) {
        if (ptinrect(fgrect,mx,my)) {
            colchangep = true;
            mfgp = true; mdownp = true;
        } else if (ptinrect(bgrect,mx,my)) {
            colchangep = true;
            mfgp = false; mdownp = true;
        } else {
            colchangep = false;
        }
        curmx = mx; curmy =my;
    }
    
    public void mouseDrag(Event ev, int mx, int my) {
        curmx = mx; curmy =my;
    }
    
    public void mouseUp(Event ev, int mx, int my) {
        curmx = mx; curmy =my; mdownp = false;
        if (colchangep) {
            if (mfgp) {
                System.out.println("got in mouseUp statement");
                target.message("FGColor Change",fgcol);
            } else {
                target.message("BGColor Change",bgcol);
            }
        }
    }

    public void draw(Graphics g)
    {

        if (fgrect==null) {
            int fdim = 20;
            if (!fgbgp) {
                fdim=fdim*3/2;
                fgrect = new Rectangle(cx+cw/2-fdim/2,cy+cw/2-fdim/2,fdim,fdim);
                bgrect = new Rectangle(-10,-10,0,0); /// where you can't see it
            } else {
                fgrect = new Rectangle(cx+cw/2-fdim*2/3,cy+cw/2-fdim*2/3,fdim,fdim);
                bgrect = new Rectangle(cx+cw/2-fdim*1/3,cy+cw/2-fdim*1/3,fdim,fdim);
            }
        }
        if (mdownp) {
            if (mfgp) {
                g.setColor(fgcol); g.fillRect(fgrect.x,fgrect.y,fgrect.width,fgrect.height);
                g.setColor(Color.black); g.drawRect(fgrect.x,fgrect.y,fgrect.width,fgrect.height);

                g.drawImage(cim,fgrect.x+fgrect.width,fgrect.y+fgrect.height-cimh,app);
                drawhighl(g,fgrect.x+fgrect.width,fgrect.y+fgrect.height-cimh,cimw,cimh);

            } else {
                g.setColor(bgcol); g.fillRect(bgrect.x,bgrect.y,bgrect.width,bgrect.height);
                g.setColor(Color.black); g.drawRect(bgrect.x,bgrect.y,bgrect.width,bgrect.height);

                g.drawImage(cim,bgrect.x+bgrect.width,bgrect.y+bgrect.height-cimh,app);
                drawhighl(g,bgrect.x+bgrect.width,bgrect.y+bgrect.height-cimh,cimw,cimh);
            }
        }else {
            g.setColor(Color.white);g.fillRect(cx,cy,cw,ch);
            g.setColor(Color.black);g.drawRect(cx,cy,cw-1,ch-1);

            g.setColor(bgcol); g.fillRect(bgrect.x,bgrect.y,bgrect.width,bgrect.height);
            g.setColor(Color.black); g.drawRect(bgrect.x,bgrect.y,bgrect.width,bgrect.height);
            g.setColor(fgcol); g.fillRect(fgrect.x,fgrect.y,fgrect.width,fgrect.height);
            g.setColor(Color.black); g.drawRect(fgrect.x,fgrect.y,fgrect.width,fgrect.height);
        }

    }

    public boolean keyDown(Event ev, int k) {
        return false;
    }

    public void message(String fromWho, Object odat) {}

}
